// Copyright 2022 Jens W. Wulf, originally published at http://www.jwwulf.de/en/kbd/
// This file licensed under the
// Creative Commons Attribution-NonCommercial-ShareAlike 4.0 International License.
// To view a copy of this license, visit
// https://creativecommons.org/licenses/by-nc-sa/4.0/

// Länge in x-, y- und z-Richtung, Radius zur Verrundung und dessen fn.
// Kann als Ersatz für cube benutzt werden.
module jw_rect_round(lx, ly, lz, r, fn, center) {
  if (center == true)
  {
    hull() {
      dx = lx/2;
      dy = ly/2;
      translate([-dx+r,   -dy+r,   0]) cylinder($fn=fn, lz, r, r, true);
      translate([-dx+r,   -dy+ly-r,0]) cylinder($fn=fn, lz, r, r, true);
      translate([-dx+lx-r,-dy+r,   0]) cylinder($fn=fn, lz, r, r, true);
      translate([-dx+lx-r,-dy+ly-r,0]) cylinder($fn=fn, lz, r, r, true);
    }
  }
  else
  {
    hull() {
      dz = lz/2;
      translate([r,   r,   dz]) cylinder($fn=fn, lz, r, r, true);
      translate([r,   ly-r,dz]) cylinder($fn=fn, lz, r, r, true);
      translate([lx-r,r,   dz]) cylinder($fn=fn, lz, r, r, true);
      translate([lx-r,ly-r,dz]) cylinder($fn=fn, lz, r, r, true);
    }
  }
}
